#!/usr/bin/env ruby
require File.dirname(__FILE__) + '/../config/boot'
require RAILS_ROOT + '/config/environment'

if $stdin.isatty
  $stderr.puts "Warning: Expecting feed on stdin, but it's a tty."
end

require "rexml/document"
doc = REXML::Document.new $stdin
doc.elements.each("feed") { |feed|
  # avoid importing feed URL, name, author info, because that's
  # easy enough to setup in the typo UI and would be annoying to unchange
  # if you import after already setting it up
  puts "Parsing feed: #{feed.elements["title"].text}"
  feed.elements.each("entry") { |e|
    puts "Parsing entry: #{e.elements["title"].text}"
    a = Blog.find(:first).articles.create
    a.updated_at = e.elements["updated"].text
    a.published_at = e.elements["published"].text
    a.title = e.elements["title"].text
    a.body = e.elements["content/div"].to_s
    a.guid = e.elements["id"].text
    a.permalink = a.stripped_title
    a.user = User.find(:first)
    a.author = a.user.login
    a.extended = ""
    a.text_filter = TextFilter.find_by_name("none")
    # Force time zone to be interpretted at day granularity as before
    a.published_at = 
      Time.parse(a.published_at.xmlschema.split('T')[0]+"T00:00:00Z")
    a.save
    # Check defaults of: extended, *_at, guid
    #puts a.attributes.inspect
    #puts Article.find(1).inspect
  }
}
#puts Article.find(:all).inspect

# Trying to get published date at mighnight GMT
#Article.find(:all).each { |a| a.published_at = Time.parse(a.published_at.xmlschema.split('T')[0]+"T00:00:00Z"); if a.guid[0, 4] == "http"; a.save; else puts "not saving #{a.guid}"; end }; nil


